Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-cstc_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-cstc_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-cstc_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration with ICE, ERA5 forcing
+!!             STATION_ASF configuration with ICE, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-ECMWF-CSTC'  !  experience name
+   cn_exp      =  'STATION_ASF-ECMWF-CSTC_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
@@ -75,5 +75,5 @@
 !!            ***  Surface Boundary Condition namelists  ***          !!
 !!                                                                    !!
-!!                           STATION_ASF case                         !!
+!!                           STATION_ASF test-case                         !!
 !!                                                                    !!
 !!   namsbc          surface boundary condition manager                 (default: NO selection)
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lg15_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lg15_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lg15_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration with ICE, ERA5 forcing
+!!             STATION_ASF configuration with ICE, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-ECMWF-LG15'  !  experience name
+   cn_exp      =  'STATION_ASF-ECMWF-LG15_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lu12_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lu12_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce+ice/namelist_ecmwf-lu12_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration with ICE, ERA5 forcing
+!!             STATION_ASF configuration with ICE, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-ECMWF-LU12'  !  experience name
+   cn_exp      =  'STATION_ASF-ECMWF-LU12_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_andreas_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_andreas_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_andreas_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration, ERA5 forcing
+!!             STATION_ASF configuration, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-ANDREAS'  !  experience name
+   cn_exp      =  'STATION_ASF-ANDREAS_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_coare3p6_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_coare3p6_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_coare3p6_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration, ERA5 forcing
+!!             STATION_ASF configuration, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-COARE3p6'  !  experience name
+   cn_exp      =  'STATION_ASF-COARE3p6_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
@@ -115,6 +115,6 @@
       rn_zu        = 10.     !  Wind vector reference height (m)
       nn_iter_algo = 20      !  Number of iterations in bulk param. algo ("stable ABL + weak wind" requires more)
-      ln_skin_cs = .true.    !  use the cool-skin parameterization
-      ln_skin_wl = .true.    !  use the warm-layer parameterization
+      ln_skin_cs   = .true.  !  use the cool-skin parameterization
+      ln_skin_wl   = .true.  !  use the warm-layer parameterization
    !
    ln_humi_sph = .false. !  humidity "sn_humi" is specific humidity  [kg/kg]
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ecmwf_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ecmwf_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ecmwf_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration, ERA5 forcing
+!!             STATION_ASF configuration, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-ECMWF'  !  experience name
+   cn_exp      =  'STATION_ASF-ECMWF_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s
Index: NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ncar_cfg
===================================================================
--- NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ncar_cfg	(revision 13675)
+++ NEMO/branches/2020/dev_r13648_ASINTER-04_laurent_bulk_ice/tests/STATION_ASF/EXPREF/ERA5_arctic/oce/namelist_ncar_cfg	(revision 13676)
@@ -2,5 +2,5 @@
 !! NEMO/OCE  Configuration namelist : overwrite default values defined in SHARED/namelist_ref
 !!>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-!!             STATION_ASF configuration, ERA5 forcing
+!!             STATION_ASF configuration, ERA5_arctic forcing
 !!======================================================================
 !!              ***  Domain & Run management namelists  ***           !!
@@ -26,5 +26,5 @@
 &namrun        !   parameters of the run
 !-----------------------------------------------------------------------
-   cn_exp      =  'STATION_ASF-NCAR'  !  experience name
+   cn_exp      =  'STATION_ASF-NCAR_ERA5_arctic'  !  experience name
    nn_it000    =    1   !  first time step
    nn_itend    =    8760   !  last  time step => 3 years (including 1 leap!) at dt=3600s